   import List (delete)
   ------------------------------------------------------
   --     
   --        ,
   --    
   ---------------------------------
   ud1:: [a] -> [a] 
   ud1 []        = []
   ud1 [x]       = [x]
   ud1 (x:y:lst) = x : ud1 lst
   ---------------------------------------------------
   --     
   --       ,
   --    
   ---------------------------------
   ud2:: [a] -> [a]
   ud2 lst | null lst        = []
           | null (tail lst) = lst
           | True            = head lst : ud2 (tail (tail lst))
   ------------------------------------------------------------
   --     
   --        ,
   --    
   -----------------------------------
   ud3:: [a] -> [a] 
   ud3 []        = []
   ud3 [x]       = []
   ud3 (x:y:lst) = y : ud3 lst
   -----------------------------------------------
   --     x   lst
   -- ( )
   -------------------------------------
   delAll x lst | not $ elem x lst = lst
                | True             = delAll x (delete x lst)
   ---------------------------------------------------------
   --     x   lst
   -- (  )
   ---------------------------------
   delAll' x lst | null lst    = lst
                 | x==head lst = delAll' x (tail lst)
                 | True        = (:) (head lst) (delAll' x (tail lst))
   -- ****************************************************************
   --   :
   --------------------------------------------------
   test1 =   ud1 [2]                           == [2]
          && ud1 [2,-2]                        == [2]
          && ud1 [2,-2,-3,3,-4]                == [2,-3,-4]
          && ud1 [1,2,3,4,5,6,7,8,9]           == [1,3,5,7,9]
          && ud1 [[1],[2,3],[4,5,6,7],[8],[9]] == 
                 [[1],      [4,5,6,7],    [9]]
           ------------------------------------------
          && ud2 [2]                           == [2]
          && ud2 [2,-2]                        == [2]
          && ud2 [2,-2,-3,3,-4]                == [2,-3,-4]
          && ud2 [1,2,3,4,5,6,7,8,9]           == 
                 [1,  3,  5,  7,  9]
          && ud2 [[1],[2,3],[4,5,6,7],[8],[9]] == 
                 [[1],      [4,5,6,7],    [9]]
          ------------------------------------------
          && ud3 [2]                           == []
          && ud3 [2,-2]                        == [-2]
          && ud3 [2,-2,-3,3,-4]                == [-2,3]
          && ud3 [1,2,3,4,5,6,7,8,9]           == 
                 [  2,  4,  6,  8  ]
          && ud3 [[1],[2,3],[4,5,6,7],[8],[9]] == 
                 [    [2,3],          [8]    ]
   -------------------------------------------
   test2 = putStr (ud1 [])
   test3 = putStr (ud2 [])
   -----------------------------------
   test4 = delAll 'a' "1a2a3a4a5a6a7a"
   test5 = delAll' 'a' "1a2a3a4a5a6a7a"

